
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.image.BufferStrategy;
import java.util.ArrayList;

public class MyCanvas extends Canvas {

    private final int w;
    private final int h;
    private final ArrayList<Drawable> objects;
    private BufferStrategy strategy;
    private boolean firstDraw;
    private final Color backgroundColor;

    public MyCanvas(Dimension dim) {
        w = dim.width;
        h = dim.height;
        setIgnoreRepaint(true);
        objects = new ArrayList();
        setMinimumSize(dim);
        setPreferredSize(dim);
        setMaximumSize(dim);
        firstDraw = false;
        backgroundColor = new Color(200, 200, 200);
    }

    public void addObject(Drawable obj) {
        objects.add(obj);
    }

    public void redraw() {
        if (strategy != null) {
            Graphics2D g2d = (Graphics2D) strategy.getDrawGraphics();
            g2d.setColor(backgroundColor);
            g2d.clearRect(0, 0, w, h);
            for (Drawable obj : objects) {
                obj.draw(g2d);
            }
            strategy.show();
        } else {
            createBufferStrategy(2);
            strategy = getBufferStrategy();
            firstDraw = true;
            redraw();
        }
    }

}
